Index: trunk/src/lib/network/peer_info.h
===================================================================
--- trunk/src/lib/network/peer_info.h	(revision 9406)
+++ trunk/src/lib/network/peer_info.h	(revision 9406)
@@ -0,0 +1,47 @@
+/*!
+ * @file peer_info.h
+ *  implementation a peer info
+ */
+
+#ifndef _PEER_INFO_H
+#define _PEER_INFO_H
+
+#include "server_socket.h"
+#include "handshake.h"
+#include "monitor/connection_monitor.h"
+
+#include <string>
+
+//!< this structure contains informations about the network node
+class PeerInfo
+{
+  public:
+    PeerInfo();
+
+    void clear();
+
+
+    inline bool isMasterServer() { return this->nodeType == NET_MASTER_SERVER; }
+    inline bool isProxyServer() { return this->nodeType == NET_PROXY_SERVER_ACTIVE; }
+    inline bool isProxyServerPassive() { return this->nodeType == NET_PROXY_SERVER_PASSIVE; }
+    inline bool isClient() { return this->nodeType == NET_CLIENT; }
+
+    std::string getNodeTypeString();
+
+
+  public:
+    int                 userId;                  //!< id of this network node
+    int                 nodeType;                //!< type of this network node
+    IP                  ip;                      //!> the ip address of this network node
+
+    NetworkSocket *     socket;                  //!< socket connecting to this node
+    Handshake *         handshake;               //!< the handshake object, active on connection setup
+    ConnectionMonitor * connectionMonitor;       //!< ConnectionMonitor monitoring the current network traffic
+
+    int                 lastAckedState;          //!< last acked state synchronized state
+    int                 lastRecvedState;         //!< last received state
+};
+
+
+
+#endif /* _PEER_INFO_H */
Index: trunk/src/lib/network/player_stats.cc
===================================================================
--- trunk/src/lib/network/player_stats.cc	(revision 9391)
+++ trunk/src/lib/network/player_stats.cc	(revision 9406)
@@ -23,4 +23,6 @@
 #include "shared_network_data.h"
 
+#include "converter.h"
+
 #include "preferences.h"
 
@@ -38,5 +40,5 @@
 {
   init();
-  
+
   this->userId = userId;
 }
@@ -62,5 +64,5 @@
   this->nickName = "Player";
   this->oldNickName = "Player";
-  
+
   userId_handle = registerVarId( new SynchronizeableInt( &userId, &userId, "userId" ) );
   teamId_handle = registerVarId( new SynchronizeableInt( &teamId, &teamId, "teamId" ) );
@@ -71,7 +73,7 @@
   modelFileName_handle = registerVarId( new SynchronizeableString( &modelFileName, &modelFileName, "modelFileName" ) );
   nickName_handler = registerVarId( new SynchronizeableString( &nickName, &nickName, "nickName" ) );
-  
+
   MessageManager::getInstance()->registerMessageHandler( MSGID_CHANGENICKNAME, changeNickHandler, NULL );
-  
+
   PRINTF(0)("PlayerStats created\n");
 }
@@ -96,8 +98,8 @@
   {
     this->setPlayableUniqueId( this->playableUniqueId );
-    
+
     PRINTF(0)("uniqueID changed %d %d %d\n", userId, SharedNetworkData::getInstance()->getHostID(), getUniqueID());
   }
-  
+
   if ( std::find( id.begin(), id.end(), nickName_handler ) != id.end() )
   {
@@ -115,10 +117,10 @@
 {
   const std::list<BaseObject*> * list = ClassList::getList( CL_PLAYER_STATS );
-  
+
   if ( !list )
   {
     return NULL;
   }
-  
+
   for ( std::list<BaseObject*>::const_iterator it = list->begin(); it != list->end(); it++ )
   {
@@ -128,5 +130,5 @@
     }
   }
-  
+
   return NULL;
 }
@@ -138,5 +140,5 @@
 {
   const std::list<BaseObject*> * list = ClassList::getList( CL_PLAYABLE );
-  
+
   if ( !list )
   {
@@ -144,5 +146,5 @@
     return;
   }
-  
+
   this->playable = NULL;
   for ( std::list<BaseObject*>::const_iterator it = list->begin(); it != list->end(); it++ )
@@ -156,10 +158,10 @@
     }
   }
-  
+
   if ( this->playable && userId == SharedNetworkData::getInstance()->getHostID() )
   {
     State::getPlayer()->setPlayable( this->playable );
   }
-  
+
   this->playableUniqueId = uniqueId;
 }
@@ -173,11 +175,11 @@
   if ( playable )
     return playable;
-  
+
   assert( playableUniqueId > 0 );
-  
+
   setPlayableUniqueId( playableUniqueId );
-  
+
   assert( playable );
-  
+
   return playable;
 }
@@ -189,5 +191,5 @@
 void PlayerStats::setNickName( std::string nick )
 {
-  if ( SharedNetworkData::getInstance()->isGameServer() )
+  if ( SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer() )
   {
     this->nickName = nick;
@@ -199,7 +201,7 @@
   {
     byte * data = new byte[nick.length()+INTSIZE];
-    
+
     assert( Converter::stringToByteArray( nick, data, nick.length()+INTSIZE) == nick.length()+INTSIZE );
-    
+
     MessageManager::getInstance()->sendMessage( MSGID_CHANGENICKNAME, data, nick.length()+INTSIZE, RT_SERVER, 0, MP_HIGHBANDWIDTH );
     return;
@@ -211,5 +213,5 @@
   std::string newNick;
   int res = Converter::byteArrayToString( data, newNick, dataLength );
-  
+
   if ( res != dataLength )
   {
@@ -217,8 +219,8 @@
     newNick = "invalid";
   }
-  
+
   if ( PlayerStats::getStats( userId ) )
     PlayerStats::getStats( userId )->setNickName( newNick );
-  
+
   return true;
 }
@@ -228,5 +230,5 @@
   if ( getStats( SharedNetworkData::getInstance()->getHostID() ) )
     getStats( SharedNetworkData::getInstance()->getHostID() )->setNickName( newNick );
-    
+
   Preferences::getInstance()->setString( "multiplayer", "nickname", newNick );
 }
@@ -237,5 +239,5 @@
 {
   const std::list<BaseObject*> * list;
-  
+
   while ( (list  = ClassList::getList( CL_PLAYER_STATS )) != NULL && list->begin() != list->end() )
     delete *list->begin();
@@ -247,30 +249,30 @@
 {
   ScoreList result;
-  
+
   const std::list<BaseObject*> * list = ClassList::getList( CL_PLAYER_STATS );
-  
+
   if ( !list )
   {
     return result;
   }
-  
+
   for ( std::list<BaseObject*>::const_iterator it = list->begin(); it != list->end(); it++ )
   {
     PlayerStats & stats = *dynamic_cast<PlayerStats*>(*it);
-    
+
     TeamScoreList::iterator it = result[stats.getTeamId()].begin();
-    
+
     while (  it != result[stats.getTeamId()].end() && stats.score > it->score )
     {
       it++;
     }
-    
+
     PlayerScore score;
     score.name = stats.getNickName();
     score.score = stats.getScore();
-    
+
     result[stats.getTeamId()].insert(it, score);
   }
-  
+
   return result;
 }
Index: trunk/src/lib/network/proxy/network_settings.cc
===================================================================
--- trunk/src/lib/network/proxy/network_settings.cc	(revision 9406)
+++ trunk/src/lib/network/proxy/network_settings.cc	(revision 9406)
@@ -0,0 +1,154 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+
+#define DEBUG_MODULE_NETWORK
+
+#include "network_settings.h"
+
+#include "netdefs.h"
+#include "shared_network_data.h"
+
+#include "loading/resource_manager.h"
+#include "loading/load_param.h"
+
+#include "debug.h"
+
+
+
+NetworkSettings* NetworkSettings::singletonRef = NULL;
+
+/**
+ * Standard constructor
+ */
+NetworkSettings::NetworkSettings()
+{
+  /* set the class id for the base object */
+  this->setClassID(CL_NETWORK_SETTINGS, "NetworkSettings");
+
+  // suggest a good standard max players value
+  this->maxPlayer = 10;
+
+//   this->loadData();
+}
+
+
+/**
+ * Standard destructor
+ */
+NetworkSettings::~NetworkSettings()
+{
+  NetworkSettings::singletonRef = NULL;
+
+  // remove all unused proxy data again
+  for( int i = 0; i < this->proxies.size(); i++)
+  {
+    IPaddress* ip = this->proxies.back();
+    this->proxies.pop_back();
+    delete ip;
+  }
+}
+
+
+/**
+ *  this loads the proxy settings from a configuration file
+ */
+void NetworkSettings::loadData()
+{
+  std::string fileName = ResourceManager::getInstance()->getDataDir();
+  fileName += "configs/network_settings.conf";
+
+  TiXmlDocument doc(fileName);
+  if( !doc.LoadFile(fileName))
+  {
+    PRINTF(1)("Loading file %s failed for Network Settings.\n", fileName.c_str());
+    return;
+  }
+  const TiXmlElement* root = doc.RootElement();
+
+  if( strcmp( root->Value(), "NetworkSettings"))
+  {
+    // report an error
+    PRINTF(1)("Specified XML File is not an orxonox Network Settings file (NetworkSettings element missing)\n");
+    return;
+  }
+
+  this->loadNetworkSettings( root);
+
+  // set the new unique id offset
+  // setUniqueID( maxCon+2 ) because we need one id for every handshake
+  // and one for handshake to reject client maxCon+1
+  SharedNetworkData::getInstance()->setNewUniqueID( this->maxPlayer + 2);
+}
+
+
+
+/**
+ * load the proxy settings
+ * @param root: the root element of the xml elemnts
+ */
+void NetworkSettings::loadNetworkSettings(const TiXmlElement* root)
+{
+  LoadParam(root, "master-addr", this, NetworkSettings, setMasterAddr);
+
+  LoadParam(root, "max-player", this, NetworkSettings, setMaxPlayer);
+
+
+  LOAD_PARAM_START_CYCLE(root, element);
+  {
+    element->ToText();
+    LoadParam_CYCLE(element, "proxy-addr", this, NetworkSettings, setProxyAddr);
+  }
+  LOAD_PARAM_END_CYCLE(element);
+
+}
+
+
+/**
+ * sets the master server address
+ * @param masterAddr: the address of the master server
+ */
+void NetworkSettings::setMasterAddr(const std::string& masterAddr)
+{
+  IPaddress *ip = new IPaddress;
+
+  SDLNet_ResolveHost( ip, masterAddr.c_str(), 9999 );
+
+  this->masterServer = *ip;
+}
+
+
+/**
+ * sets the proxy address to
+ *  @param proxyAddr: the proxy address
+ */
+void NetworkSettings::setProxyAddr(const std::string& proxyAddr)
+{
+
+  if( !SharedNetworkData::getInstance()->isMasterServer())
+    return;
+
+  IPaddress *ip = new IPaddress;
+
+  SDLNet_ResolveHost( ip, proxyAddr.c_str(), 9999 );
+
+  this->proxies.push_back(ip);
+}
+
+
+
+
+
+
+
Index: trunk/src/lib/network/proxy/network_settings.h
===================================================================
--- trunk/src/lib/network/proxy/network_settings.h	(revision 9406)
+++ trunk/src/lib/network/proxy/network_settings.h	(revision 9406)
@@ -0,0 +1,64 @@
+/*!
+ * @file proxy_settings.h
+ *  some shared data from the proxy settings
+ */
+
+#ifndef _NETWORK_SETTINGS_H
+#define _NETWORK_SETTINGS_H
+
+#include "base_object.h"
+#include "netdefs.h"
+
+#include "debug.h"
+#include "ip.h"
+
+#include <vector>
+
+
+class NetworkStream;
+class Synchronizeable;
+class TiXmlElement;
+
+
+/* and here is the class itsself*/
+class NetworkSettings : public BaseObject
+{
+
+  public:
+    inline static NetworkSettings* getInstance() { if (!NetworkSettings::singletonRef) NetworkSettings::singletonRef = new NetworkSettings();
+      return NetworkSettings::singletonRef; }
+    virtual ~NetworkSettings();
+
+    void loadData();
+
+    void loadNetworkSettings(const TiXmlElement* root);
+
+    /** @param number: sets the max number of players */
+    inline void setMaxPlayer(int number) { this->maxPlayer = number; }
+    /** @returns teh max number of players */
+    int getMaxPlayer() { return this->maxPlayer; }
+
+    void setMasterAddr(const std::string& masterAddr);
+    /** @returns the address of the master server read from the network config file */
+    inline IP getMasterAddr() { return this->masterServer; }
+
+    void setProxyAddr(const std::string& proxyAddr);
+    /** @returns the list of proxy servers from the init file */
+    inline std::vector<IPaddress*>* getProxyList() { return &this->proxies; }
+
+
+  private:
+    NetworkSettings();
+
+
+  private:
+    static NetworkSettings*        singletonRef;            //!< Pointer to the only instance of this Class
+    int                          maxPlayer;               //!< maximal number of players
+    std::vector<IPaddress*>      proxies;                 //!< all registered proxies
+    IP                           masterServer;            //!< master server ip address
+
+};
+
+
+
+#endif /* _NETWORK_SETTINGS_H */
Index: trunk/src/lib/network/shared_network_data.cc
===================================================================
--- trunk/src/lib/network/shared_network_data.cc	(revision 9391)
+++ trunk/src/lib/network/shared_network_data.cc	(revision 9406)
@@ -18,7 +18,8 @@
 #include "shared_network_data.h"
 #include "netdefs.h"
+#include "state.h"
 
+#include "debug.h"
 
-using namespace std;
 
 
@@ -33,8 +34,11 @@
   this->setClassID(CL_SHARED_NETWORK_DATA, "SharedNetworkData");
 
+  this->nodeType = NET_CLIENT;
   this->hostID = -1;
   this->defaultSyncStream = NULL;
-  this->newUniqueID = MAX_CONNECTIONS + 2;
-  this->bGameServer = false;
+
+  // setUniqueID( maxCon+2 ) because we need one id for every handshake
+  // and one for handshake to reject client maxCon+1
+  this->newUniqueID = 2;
 }
 
Index: trunk/src/lib/network/shared_network_data.h
===================================================================
--- trunk/src/lib/network/shared_network_data.h	(revision 9391)
+++ trunk/src/lib/network/shared_network_data.h	(revision 9406)
@@ -8,10 +8,13 @@
 
 #include "base_object.h"
+#include "netdefs.h"
+#include "proxy/network_settings.h"
 
+//!< maximal connectinons for the server
+#define NET_MAX_CONNECTIONS 2
 
 class NetworkStream;
 class Synchronizeable;
-template<typename>
-    class tList;
+
 
 /* and here is the class itsself*/
@@ -25,10 +28,19 @@
 
     /** @returns the next uniqueID free for an object */
-    inline int getNewUniqueID() { return ( this->bGameServer)?this->newUniqueID++:-1; }
+    inline int getNewUniqueID() { return ( this->nodeType != NET_CLIENT)?this->newUniqueID++:-1; }
+    /** sets the @param newUniqueID: the new offset for the next unique id */
+    inline void setNewUniqueID(int newUniqueID) { this->newUniqueID = newUniqueID; }
 
-    /** @returns true is this node is a game server */
-    inline bool isGameServer() { return this->bGameServer; }
+    /** @returns true is this node is a master server */
+    inline bool isMasterServer() { return this->nodeType == NET_MASTER_SERVER; }
+    /** @returns true is this node is a proxy server */
+    inline bool isProxyServer() { return this->nodeType == NET_PROXY_SERVER_ACTIVE; }
+    /** @returns true is this node is a client*/
+    inline bool isClient() { return this->nodeType == NET_CLIENT; }
     /** sets the game server flag @param bGameServer true if it is a game server */
-    inline void setGameServer(bool bGameServer) { this->bGameServer = bGameServer; }
+    inline void setNodeType(int nodeType) { this->nodeType = nodeType; }
+
+    /** @returns the maximum number of players for this server */
+    inline int getMaxPlayer() { return NetworkSettings::getInstance()->getMaxPlayer(); }
 
     /** @returns the hostID of the node */
@@ -49,5 +61,6 @@
   private:
     int                             newUniqueID;             //!< next uniqueID
-    bool                            bGameServer;             //!< true if it is a server
+    int                             nodeType;                //!< saves the node type here
+
     int                             hostID;                  //!< The Host-ID of the Manager
     NetworkStream*                  defaultSyncStream;       //!< default synchronize NetworkStream
Index: trunk/src/lib/network/synchronizeable.cc
===================================================================
--- trunk/src/lib/network/synchronizeable.cc	(revision 9391)
+++ trunk/src/lib/network/synchronizeable.cc	(revision 9406)
@@ -11,6 +11,6 @@
 
 ### File Specific:
-   main-programmer: Silvan Nellen
-   co-programmer: Benjamin Wuest
+   main-programmer: Christoph Renner (rennerc@ee.ethz.ch)
+   co-programmer: Patrick Boenzli (patrick@orxonox.ethz.ch)
 */
 
@@ -29,4 +29,6 @@
 #include "synchronizeable.h"
 
+#include "converter.h"
+
 
 
@@ -38,9 +40,9 @@
   this->setClassID(CL_SYNCHRONIZEABLE, "Synchronizeable");
   this->owner = 0;
-  this->setIsServer(SharedNetworkData::getInstance()->getHostID() == 0);
+//   this->setIsServer(SharedNetworkData::getInstance()->getHostID() == 0);
   this->uniqueID = NET_UID_UNASSIGNED;
   this->networkStream = NULL;
   this->bSynchronize = false;
-  
+
   if( State::isOnline())
   {
@@ -54,5 +56,5 @@
   assert( syncVarList.size() == 0 );
   mLeafClassId = this->registerVarId( new SynchronizeableInt( (int*)&this->getLeafClassID(), (int*)&this->getLeafClassID(), "leafClassId" ) );
-    
+
   this->registerVar( new SynchronizeableInt( &this->owner, &this->owner, "owner" ) );
   this->registerVar( new SynchronizeableString( &this->objectName, &this->objectName, "objectName" ) );
@@ -69,9 +71,10 @@
   {
     this->networkStream->disconnectSynchronizeable(*this);
-  
-    if ( this->isServer() && this->beSynchronized() && this->getUniqueID() > 0 && !this->isA( CL_MESSAGE_MANAGER ) )
+
+    if ( (SharedNetworkData::getInstance()->isMasterServer() || SharedNetworkData::getInstance()->isProxyServer() )
+           && this->beSynchronized() && this->getUniqueID() > 0 && !this->isA( CL_MESSAGE_MANAGER ) )
       NetworkGameManager::getInstance()->removeSynchronizeable( this->getUniqueID() );
   }
-    
+
   for ( SyncVarList::iterator it = syncVarList.begin(); it != syncVarList.end(); it++ )
   {
@@ -79,5 +82,5 @@
   }
   syncVarList.clear();
-  
+
   for ( UserStateHistory::iterator it = recvStates.begin(); it != recvStates.end(); it++ )
   {
@@ -93,5 +96,5 @@
 
   }
-  
+
   for ( UserStateHistory::iterator it = sentStates.begin(); it != sentStates.end(); it++ )
   {
@@ -105,32 +108,19 @@
       delete *it2;
     }
-
-  }
-}
-
-/**
- * Sets the server flag to a given value
- * @param isServer: the boolean value which the server flag is to set to
- */
-void Synchronizeable::setIsServer(bool isServer)
-{
-  if( isServer )
-    this->state = this->state | STATE_SERVER;
-  else
-    this->state = this->state & (~STATE_SERVER);
-}
-
-
-/**
- * Determines if the server flag is set
- * @return true, if the server flag is true, false else
- */
-bool Synchronizeable::isServer()
-{
-  return (this->state & STATE_SERVER) >0;
-}
-
-
-
+  }
+}
+
+
+
+/**
+ * creates a diff image from two states
+ * @param userId: the userid of the user where the image will be sent to
+ * @param data: the binary data array to write to
+ * @param maxLength: maximal length of the data written (length of available space in the array)
+ * @param stateId: the state id that this diff will represent
+ * @param priorityTH: the priority threshold: all syncs below this threshold won't be synchronized
+ *
+ * @todo check for permissions
+ */
 int Synchronizeable::getStateDiff( int userId, byte* data, int maxLength, int stateId, int fromStateId, int priorityTH )
 {
@@ -169,5 +159,5 @@
         (*it2)->data = NULL;
       }
-      
+
       delete *it2;
     }
@@ -181,9 +171,4 @@
   while ( it != sentStates[userId].end() && (*it)->stateId != fromStateId )
     it++;
-  
-//  if ( getLeafClassID() == CL_SPACE_SHIP )
-//  {
-//    PRINTF(0)("getStateDiff:SpaceShip from: %d stateId: %d\n", (it == sentStates[userId].end())?-1:fromStateId, stateId);
-//  }
 
   if ( it == sentStates[userId].end() )
@@ -196,5 +181,5 @@
 
     stateFrom = initialEntry;
-    
+
     sentStates[userId].push_back( stateFrom );
   }
@@ -205,5 +190,5 @@
 
   sentStates[userId].push_back( stateTo );
-  
+
   stateTo->stateId = stateId;
   stateTo->dataLength = neededSize;
@@ -214,6 +199,6 @@
   int i = 0;
   int n;
-  
-  bool hasPermission;
+
+  bool hasPermission = false;
   bool sizeChanged = false;
 
@@ -221,20 +206,40 @@
   for ( SyncVarList::iterator it = syncVarList.begin(); it != syncVarList.end(); it++ )
   {
-    hasPermission = (
-            this->isServer() && (*it)->checkPermission( PERMISSION_SERVER ) ||
-        this->owner == SharedNetworkData::getInstance()->getHostID() && (*it)->checkPermission( PERMISSION_OWNER ) ||
-            this->isServer() && this->owner != userId && (*it)->checkPermission( PERMISSION_OWNER ) ||
-            (*it)->checkPermission( PERMISSION_ALL ) 
-                    );
-    
-    if ( sizeIter == stateFrom->sizeList.end() || *sizeIter != (*it)->getSize() ) 
+    // DATA PERMISSIONS
+    // check if this synchronizeable has the permissions to write the data
+
+    // first check MASTER_SERVER permissions
+    if( SharedNetworkData::getInstance()->isMasterServer() && (*it)->checkPermission( PERMISSION_MASTER_SERVER ))
+      hasPermission = true;
+    // now check PROXY_SERVER permissions
+    else if( SharedNetworkData::getInstance()->isProxyServer() && (*it)->checkPermission( PERMISSION_MASTER_SERVER ))
+      hasPermission = true;
+    // now check OWNER permissions
+    else if( this->owner == SharedNetworkData::getInstance()->getHostID() && (*it)->checkPermission( PERMISSION_OWNER ))
+      hasPermission = true;
+    // now check ALL permissions
+    else if( (*it)->checkPermission( PERMISSION_ALL ))
+      hasPermission = true;
+    // SPECIAL: get write permissions if i am master server and i am able to overwrite the client stuff
+    else if( SharedNetworkData::getInstance()->isMasterServer() && this->owner != userId && (*it)->checkPermission( PERMISSION_OWNER ))
+      hasPermission = true;
+    // SPECIAL: get write permissions if i am proxy server and i am able to overwrite the client stuff
+    else if( SharedNetworkData::getInstance()->isProxyServer()  && this->owner != userId && (*it)->checkPermission( PERMISSION_OWNER ))
+      hasPermission = true;
+    else
+      hasPermission = false;
+
+
+    if ( sizeIter == stateFrom->sizeList.end() || *sizeIter != (*it)->getSize() )
       sizeChanged = true;
-    
+
     if ( ( hasPermission && (*it)->getPriority() >= priorityTH ) || sizeChanged )
     {
       n = (*it)->writeToBuf( stateTo->data+i, stateTo->dataLength - i );
       //NETPRINTF(0)("getvar %s %d\n", (*it)->getName().c_str(), n);
+      //PRINTF(0)("getvar %s %d\n", (*it)->getName().c_str(), n);
       stateTo->sizeList.push_back( n );
-      //(*it)->debug();
+      // this is only for very hardcore debug sessions
+      // (*it)->debug();
       i += n;
     }
@@ -257,5 +262,5 @@
   if ( i != neededSize )
   {
-    PRINTF(0)("strange error: (%s) %d != %d\n", this->getClassName(), i, neededSize);
+    PRINTF(0)("strange error: (%s) %d != %d\n", this->getClassCName(), i, neededSize);
     assert(false);
   }
@@ -281,4 +286,5 @@
  * @param fromStateId id of the base state id
  * @return number bytes read
+ *
  * @todo check for permissions
  */
@@ -299,14 +305,10 @@
   StateHistoryEntry * stateFrom = NULL;
 
+  // search the state from wich the diff is made of
   StateHistory::iterator it = recvStates[userId].begin();
   while ( it != recvStates[userId].end() && (*it)->stateId != fromStateId )
     it++;
 
-  
-//  if ( getLeafClassID() == CL_SPACE_SHIP )
-//  {
-//    PRINTF(0)("setStateDiff:SpaceShip from: %d stateId: %d\n", (it == recvStates[userId].end())?-1:fromStateId, stateId);
-//  }
-
+  // if this is the first state to receive
   if ( it == recvStates[userId].end() )
   {
@@ -318,11 +320,12 @@
 
     stateFrom = initialEntry;
-    
+
     recvStates[userId].push_back( stateFrom );
   }
   else
     stateFrom = (*it);
-  
-  //apply diff
+
+
+  // apply diff
   for ( int i = 0; i<length; i++ )
   {
@@ -331,26 +334,50 @@
     else
       stateTo->data[i] = data[i];
-    
-  }
-  
+  }
+
   //add state to state history
   recvStates[userId].push_back( stateTo );
-  
+
   int i = 0;
   int n = 0;
   std::list<int> changes;
-  
+  bool hasPermission = false;
+
+  // extract the new state for every client
   for ( SyncVarList::iterator it = syncVarList.begin(); it != syncVarList.end(); it++ )
   {
-    if (
-        (*it)->checkPermission( PERMISSION_SERVER ) && networkStream->isUserServer( userId ) ||
-        (*it)->checkPermission( PERMISSION_OWNER ) && this->owner == userId ||
-        networkStream->isUserServer( userId ) && this->owner != SharedNetworkData::getInstance()->getHostID() && (*it)->checkPermission( PERMISSION_OWNER ) ||
-        (*it)->checkPermission( PERMISSION_ALL ) 
-       )
+    // DATA PERMISSIONS
+    // check if this synchronizeable has the permissions to write the data
+
+    // first check MASTER_SERVER permissions
+    if(  this->networkStream->isUserMasterServer( userId ) && (*it)->checkPermission( PERMISSION_MASTER_SERVER ))
+      hasPermission = true;
+    // now check PROXY_SERVER permissions
+    else if( this->networkStream->isUserProxyServer( userId )  && (*it)->checkPermission( PERMISSION_MASTER_SERVER ))
+      hasPermission = true;
+    // now check OWNER permissions
+    else if( this->owner == userId && (*it)->checkPermission( PERMISSION_OWNER ))
+      hasPermission = true;
+    // now check ALL permissions
+    else if( (*it)->checkPermission( PERMISSION_ALL ))
+      hasPermission = true;
+    // SPECIAL: get write permissions if im sending to a master server that does not own this sync
+    else if( this->networkStream->isUserMasterServer( userId ) && this->owner != SharedNetworkData::getInstance()->getHostID() && (*it)->checkPermission( PERMISSION_OWNER ))
+      hasPermission = true;
+    // SPECIAL: get write permissions if im sending to a proxy server that does not own this sync
+    else if( this->networkStream->isUserProxyServer( userId )  && this->owner != SharedNetworkData::getInstance()->getHostID() && (*it)->checkPermission( PERMISSION_OWNER ))
+      hasPermission = true;
+    else
+      hasPermission = false;
+
+
+
+    // if it has the permission to write do it
+    if( hasPermission)
     {
       n = (*it)->readFromBuf( stateTo->data + i, stateTo->dataLength - i );
       i += n;
-      //NETPRINTF(0)("%s::setvar %s %d\n", getClassName(), (*it)->getName().c_str(), n);
+      //NETPRINTF(0)("%s::setvar %s %d\n", getClassCName(), (*it)->getName().c_str(), n);
+      //PRINTF(0)("%s::setvar %s %d\n", getClassCName(), (*it)->getName().c_str(), n);
       //(*it)->debug();
       if ( (*it)->getHasChanged() )
@@ -361,7 +388,7 @@
     else
     {
-//      PRINTF(0)("DONT SET VAR BECAUSE OF PERMISSION: %s %d %d %d %d %d %d\n", (*it)->getName().c_str(), (*it)->checkPermission( PERMISSION_SERVER ), (*it)->checkPermission( PERMISSION_OWNER ), (*it)->checkPermission( PERMISSION_ALL ), networkStream->isUserServer( userId ), this->owner, userId );
+//      PRINTF(0)("DONT SET VAR BECAUSE OF PERMISSION: %s %d %d %d %d %d %d\n", (*it)->getName().c_str(), (*it)->checkPermission( PERMISSION_MASTER_SERVER ), (*it)->checkPermission( PERMISSION_OWNER ), (*it)->checkPermission( PERMISSION_ALL ), networkStream->isUserServer( userId ), this->owner, userId );
       n = (*it)->getSizeFromBuf( stateTo->data + i, stateTo->dataLength - i );
-      //NETPRINTF(0)("%s::setvar %s %d\n", getClassName(), (*it)->getName().c_str(), n);
+      //NETPRINTF(0)("%s::setvar %s %d\n", getClassCName(), (*it)->getName().c_str(), n);
       //(*it)->debug();
       i += n;
@@ -370,5 +397,5 @@
 
   this->varChangeHandler( changes );
-  
+
   return i;
 }
@@ -423,13 +450,13 @@
         (*it)->data = NULL;
       }
-    
+
       delete *it;
     }
     recvStates[userId].clear();
   }
- 
+
   if ( sentStates.size() > userId )
   {
-    
+
     for ( std::list<StateHistoryEntry*>::iterator it = sentStates[userId].begin(); it != sentStates[userId].end(); it++ )
     {
@@ -439,5 +466,5 @@
         (*it)->data = NULL;
       }
-    
+
       delete *it;
     }
@@ -448,7 +475,7 @@
 /**
  * this function is called after recieving a state.
- * @param userId 
- * @param stateId 
- * @param fromStateId 
+ * @param userId
+ * @param stateId
+ * @param fromStateId
  */
 void Synchronizeable::handleRecvState( int userId, int stateId, int fromStateId )
@@ -457,5 +484,5 @@
   if ( recvStates.size() <= userId )
     recvStates.resize( userId+1 );
-  
+
   //remove old states
   StateHistory::iterator it = recvStates[userId].begin();
@@ -485,5 +512,5 @@
       StateHistory::iterator delIt = it;
       it ++;
-      
+
       if ( (*delIt)->data )
       {
@@ -493,13 +520,13 @@
       delete *delIt;
       recvStates[userId].erase( delIt );
-      
+
       continue;
     }
     it++;
   }
-  
+
   StateHistory::iterator fromState = recvStates[userId].end();
   StateHistory::iterator toState = recvStates[userId].end();
-  
+
   for ( it = recvStates[userId].begin(); it != recvStates[userId].end(); it++ )
   {
@@ -508,19 +535,19 @@
     if ( (*it)->stateId == fromStateId )
       fromState = it;
-    
+
     if ( fromState != recvStates[userId].end() && toState != recvStates[userId].end() )
       break;
   }
-  
+
   // setStateDiff was not called and i know fromStateId
   if ( fromState != recvStates[userId].end() && toState == recvStates[userId].end() )
   {
     StateHistoryEntry * entry = new StateHistoryEntry;
-    
+
     entry->dataLength = (*fromState)->dataLength;
     if ( entry->dataLength > 0 )
     {
       entry->data = new byte[entry->dataLength];
-          
+
       assert( (*fromState)->data );
       memcpy( entry->data, (*fromState)->data, entry->dataLength );
@@ -528,8 +555,8 @@
     else
       entry->data = NULL;
-    
+
     entry->sizeList = (*fromState)->sizeList;
     entry->stateId = stateId;
-    
+
     recvStates[userId].push_back(entry);
   }
@@ -538,7 +565,7 @@
 /**
  * this function is called after sending a state
- * @param userId 
- * @param stateId 
- * @param fromStateId 
+ * @param userId
+ * @param stateId
+ * @param fromStateId
  */
 void Synchronizeable::handleSentState( int userId, int stateId, int fromStateId )
@@ -557,5 +584,5 @@
       StateHistory::iterator delIt = it;
       it ++;
-      
+
       if ( (*delIt)->data )
       {
@@ -565,5 +592,5 @@
       delete *delIt;
       sentStates[userId].erase( delIt );
-      
+
       continue;
     }
@@ -571,8 +598,8 @@
   }
 
-  
+
   StateHistory::iterator fromState = sentStates[userId].end();
   StateHistory::iterator toState = sentStates[userId].end();
-  
+
   for ( it = sentStates[userId].begin(); it != sentStates[userId].end(); it++ )
   {
@@ -581,20 +608,20 @@
     if ( (*it)->stateId == fromStateId )
       fromState = it;
-    
+
     if ( fromState != sentStates[userId].end() && toState != sentStates[userId].end() )
       break;
   }
 
-  
+
   // getStateDiff was not called and i know fromStateId
   if ( fromState != sentStates[userId].end() && toState == sentStates[userId].end() )
   {
     StateHistoryEntry * entry = new StateHistoryEntry;
-    
+
     entry->dataLength = (*fromState)->dataLength;
     if ( entry->dataLength > 0 )
     {
       entry->data = new byte[entry->dataLength];
-      
+
       assert( (*fromState)->data );
       memcpy( entry->data, (*fromState)->data, entry->dataLength );
@@ -602,13 +629,13 @@
     else
       entry->data = NULL;
-    
+
     entry->sizeList = (*fromState)->sizeList;
     entry->stateId = stateId;
-    
+
     sentStates[userId].push_back(entry);
   }
-  
-}
-
-
-
+
+}
+
+
+
